#ifndef bqtSphereHH
#define bqtSphereHH

#include "object.hh"
#include "mapdefs.hh"

class Sphere : public Object
{
public:
    XYZ center;
    FLOAT radius;
    Pigment Pigm;
public:
    Sphere() { }

    Sphere(const XYZ &cent, FLOAT_ARG rad, const Pigment &pig) : center(cent), radius(rad), Pigm(pig) { }
    
    virtual void TryHit(HitRec &res, const XYZ &eye, const XYZ &dir) const;

    virtual const XYZ Min() const;
    virtual const XYZ Max() const;
};

#endif
